﻿Type=StaticCode
Version=1.21
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Code module
' Edit
Sub Process_Globals
	' Edit varaibles
	Public Mode As String
	Private Page1 As Page
	Private scvEdit As ScrollView
	Private tfdEdit() As TextField
	Private sgcEdit As SegmentedControl
End Sub

Public Sub Show
	If Page1.IsInitialized = False Then
		Page1.Initialize("Page1")
		Page1.RootPanel.Color = Colors.White
		Page1.RootPanel.LoadLayout("Edit")
		InitEditPage
	End If
	Main.NavControl.ShowPage(Page1)
	InitEditButtons
	ShowEntry(Main.CurrentIndex)
End Sub
	

Sub ShowEntry(EntryIndex As Int)
	Dim i, ID As Int
	
	If Main.IDList.Size = 0 Then 			'check if database is empty
		Return													'if the database is empty leave the routine
	End If
	
	If Mode = "Add" Then
		For i = 0 To Main.ColNumber - 1
			tfdEdit(i).Text = ""
		Next
	Else
		Dim rs As ResultSet
		ID = Main.IDList.Get(EntryIndex)		'get the ID for the given entry index
		'read the entry with the given ID
		rs = Main.SQL1.ExecQuery("SELECT * FROM " & Main.SQLTabelName & " WHERE ID = " & ID)	
		rs.NextRow
		For i = 0 To Main.ColNumber - 1
			tfdEdit(i).Text = rs.GetString2(i)
		Next
		rs.Close		'close the ResultSet, we don't it anymore
	End If
	InitEditButtons
End Sub

Sub InitEditPage
	' Adds the Label and EditText views onto the ScrollView panel by code
	Private lbl(Main.ColNumber) As Label
	Public tfdEdit(Main.ColNumber) As TextField
	
	Private Height = 40dip As Int
	Private VSpace = Height + 10dip As Int
	Private lblLeft = 10dip As Int
	Private lblWidth = 0.3 * scvEdit.Width - 10dip As Int
	Private tdfLeft = 0.3 * scvEdit.Width + 10dip As Int
	Private tdfWidth = 0.7 * scvEdit.Width - 20dip As Int
	Private i As Int
	
	For i = 0 To Main.ColNumber - 1
		lbl(i).Initialize("")
		scvEdit.Panel.AddView(lbl(i), lblLeft, 10dip + i * VSpace, lblWidth, Height)
		lbl(i).Tag = i
		lbl(i).TextAlignment = lbl(i).ALIGNMENT_RIGHT
		lbl(i).Font = Font.CreateNew(16)
		lbl(i).Text = Main.ColAliasNames(i)
		lbl(i).TextColor = Colors.Black
		
		tfdEdit(i).Initialize("tfdEdit")
		scvEdit.Panel.AddView(tfdEdit(i), tdfLeft, 10dip + i * VSpace, tdfWidth, Height)
		tfdEdit(i).Tag = i
		tfdEdit(i).TextColor = Colors.Black
		tfdEdit(i).SetBorder(1dip, Colors.Black, 0)
	Next
	tfdEdit(0).Enabled = False
	scvEdit.Panel.Height = 10dip + i * VSpace
	scvEdit.Panel.Width = scvEdit.Width
End Sub

Sub InitEditButtons
	Dim lstButtons As List
	lstButtons.Initialize
	If Mode = "Add" Then
		Dim btn As BarButton
		btn.InitializeText("Add", "Add")
		lstButtons.Add(btn)
		sgcEdit.Visible = False
	Else
		Dim btn As BarButton
		btn.InitializeText("Add", "Add")
		lstButtons.Add(btn)
		btn.InitializeSystem(btn.ITEM_FLEXIBLE_SPACE, "")
		lstButtons.Add(btn)
		btn.InitializeText("Update", "Update")
		lstButtons.Add(btn)
		btn.InitializeSystem(btn.ITEM_FLEXIBLE_SPACE, "")
		lstButtons.Add(btn)
		btn.InitializeText("Delete", "Delete")
		lstButtons.Add(btn)
		sgcEdit.Visible = True
	End If
	Page1.ToolbarButtons = lstButtons
End Sub

Private Sub Page1_BarButtonClick (Tag As String)
	Select Tag
	Case "Add"
		AddEntry
		InitEditButtons
		Mode = "Edit"
	Case "Update"
		UpdateEntry
	Case "Delete"
		DeleteEntry
	End Select
End Sub

Sub AddEntry
	Dim Query As String
	Dim rs As ResultSet
	Dim i, ID As Int
	Dim Values As List
	Dim err = 0 As Int
	
	'check if all dields are filled
	For i = 1 To Main.ColNumber - 1
		If tfdEdit(i).Text = "" Then
			Main.HUD1.ToastMessageShow("No entry for " & Main.ColAliasNames(i), False)	' confirmation for the user
			Return
		End If
	Next
	
	'first we check if the entry already does exist
	Query = "SELECT * FROM " & Main.SQLTabelName & " WHERE "
	
'	Values.Initialize
	Dim Vals(Main.ColNumber - 1) As String
	For i = 1 To Main.ColNumber - 1
		If i = 1 Then
			Query = Query & Main.ColNames(i) & " = ?"
		Else
			Query = Query & " AND " & Main.ColNames(i) & " = ?"
		End If
		Vals(i - 1) = tfdEdit(i).Text
	Next
	rs = Main.SQL1.ExecQuery2(Query, Vals)

	If rs.NextRow = True Then
		'if it exists show a message and do nothing else
		Main.HUD1.ToastMessageShow("This entry already exists", False)
	Else
		'if not, add the entry
		'a NULL for the ID column increments the primary key automatically by one
		'we use ExecNonQuery2 because it's easier, we don't need to take care of the data types 
		Query = "INSERT INTO " & Main.SQLTabelName & " VALUES (NULL"
		Values.Initialize
		For i = 1 To Main.ColNumber - 1
			Query = Query & ", ?"
			Values.Add(tfdEdit(i).Text)
		Next
		Query = Query & ")"
		Main.SQL1.ExecNonQuery2(Query, Values)
		
		Main.HUD1.ToastMessageShow("Entry added", False)	' confirmation for the user
		
		'to display the ID of the last entry we read the max value of the ID column 
		ID = Main.SQL1.ExecQuerySingleResult("SELECT max(" & Main.ColNames(0) & ") FROM " & Main.SQLTabelName)
'		RowNumber = RowNumber + 1					'increase the row count
		Main.IDList.Add(ID)										'add the last ID to the list
		Main.CurrentIndex = Main.IDList.Size - 1		'set the current index to the last one
		tfdEdit(0).Text = ID										'display the last index
	End If
	rs.Close												'close the cursor, we don't it anymore
	
	Mode = "Edit"
	InitEditButtons
End Sub

Sub DeleteEntry
	Dim Question As String
	Dim i As Int
	
	'ask the user for confirmation
	Question = "Do you really want to delete " 
	For i = 1 To Main.ColNumber - 1
		Question = Question & CRLF & tfdEdit(i).Text
	Next

	Msgbox2("MsgDelete", "Delete entry", Question, Array As String("Yes", "No"))
End Sub

Private Sub MsgDelete_Click(ButtonText As String)
	If ButtonText = "Yes" Then						'if yes, delete the entry
		Dim Query As String
		Query = "DELETE FROM " & Main.SQLTabelName & " WHERE " & Main.ColNames(0) & " = " & Main.IDList.Get(Main.CurrentIndex)
		Main.SQL1.ExecNonQuery(Query)							'delete the entry
		Main.IDList.RemoveAt(Main.CurrentIndex)					'remove the ID from the list
'		If CurrentIndex = RowNumber - 1 Then	'if the current index is the last one
		If Main.CurrentIndex = Main.IDList.Size Then		'if the current index is the last one
			Main.CurrentIndex = Main.CurrentIndex - 1			'decrement it by 1
		End If
'		RowNumber = RowNumber - 1							'decrement the row count by 1
		ShowEntry(Main.CurrentIndex)								'show the next entry
		Main.HUD1.ToastMessageShow("Entry deleted", False)				'confirmation for the user
		InitEditButtons
	End If
End Sub

Sub UpdateEntry
	Dim Query As String
	Dim i As Int
	Dim Values As List
	
	If Mode = "Add" Then
		AddEntry
	Else
		Values.Initialize
		Query = "UPDATE " & Main.SQLTabelName & " Set "
		For i = 1 To Main.ColNumber - 1
			If i = 1 Then
				Query = Query & Main.ColNames(i) & " = ?"
			Else
				Query = Query & ", " & Main.ColNames(i) & " = ?"
			End If
			Values.Add(tfdEdit(i).Text)
		Next
		Query = Query & " WHERE " & Main.ColNames(0) & " = " & Main.IDList.Get(Main.CurrentIndex)
		Main.SQL1.ExecNonQuery2(Query, Values)
		Main.HUD1.ToastMessageShow("Entry updated", False)
	End If
End Sub

Private Sub sgcEdit_Click
	Dim Index As Int
	Index = sgcEdit.SelectedIndex

	Select Index
	Case 0	' ◀◀
		Main.CurrentIndex = 0
	Case 1	' ◀
		If Main.CurrentIndex > 0 Then
			Main.CurrentIndex = Main.CurrentIndex - 1
		End If
	Case 2	' ▶
		If Main.CurrentIndex < Main.IDList.Size - 1 Then
			Main.CurrentIndex = Main.CurrentIndex + 1
		End If
	Case 3	' ▶▶
		Main.CurrentIndex = Main.IDList.Size - 1
 	End Select
	
	ShowEntry(Main.CurrentIndex)
'	sgcEdit.SelectedIndex= -1
End Sub
