﻿Type=StaticCode
Version=1.21
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Code module
' Filter
Sub Process_Globals
	Private Page1 As Page

	' Filter variables
	Private scvFilter As ScrollView
	Private picFilterItems() As Picker
	Private lblFilterItems() As Label
	Public Query As String
	Public flagFilterActive = False As Boolean
	Private BooleanOperator = "AND " As String
	' Variables used to hold the selected indexes of the Spinners
	Public SelectedItemIndex() As Int
End Sub

Public Sub Show
	Dim col As Int
	
	If Page1.IsInitialized = False Then
		Page1.Initialize("SetFilter")
		Page1.RootPanel.Color = Colors.White
		InitFilterPage
	End If	
	Main.NavControl.ShowPage(Page1)
	InitFilterButtons
	For col = 1 To Main.ColNumber - 1
		UpdateFilter(col)
	Next
End Sub

Private Sub SetFilter_BarButtonClick (Tag As String)
	Select Tag
	Case "BoolOp"
		If BooleanOperator = "AND " Then
			BooleanOperator = "OR "
		Else
			BooleanOperator = "AND "
		End If
		InitFilterButtons
	Case "Filter"
		Query = GetFilterQuery
		'set the filter to active
		flagFilterActive = True
		Main.NavControl.ShowPage(Main.SQLMain)
	End Select
End Sub

Public Sub InitFilterPage
	' Adds the Label and Picker views onto the Page by code
	Public lblFilterItems(Main.ColNumber) As Label
	Private picFilterItems(Main.ColNumber) As Picker
	Dim Width = 100%x / (Main.ColNumber - 1) As Int
	Dim col As Int
	
	For col = 0 To Main.ColNumber - 2
		lblFilterItems(col).Initialize("lblItems")
		Page1.RootPanel.AddView(lblFilterItems(col), 1 + col * (Width - 1), 100 , Width, 40)
		lblFilterItems(col).Text = Main.ColAliasNames(col)
		lblFilterItems(col).TextAlignment = lblFilterItems(col).ALIGNMENT_CENTER
		lblFilterItems(col).SetBorder(1, Colors.Black, 0)
		
		picFilterItems(col).Initialize("picFilterItems")
		Page1.RootPanel.AddView(picFilterItems(col), 1 + col * (Width - 1), lblFilterItems(col).Top + lblFilterItems(col).Height - 1, Width, 180)
		picFilterItems(col).SetRowsHeight(40)
		picFilterItems(col).Tag = col
		picFilterItems(col).SetBorder(1, Colors.Black, 0)
	Next
	InitFilterButtons
End Sub

Private Sub InitFilterButtons
	Dim lstButtons As List
	lstButtons.Initialize
	Dim btn As BarButton
	If BooleanOperator = "AND " Then
		btn.InitializeText("AND", "BoolOp")
	Else
		btn.InitializeText("OR", "BoolOp")
	End If
	lstButtons.Add(btn)
	Dim btn As BarButton
	btn.InitializeSystem(btn.ITEM_FLEXIBLE_SPACE, "")
	lstButtons.Add(btn)
	Dim btn As BarButton
	btn.InitializeText("Filter", "Filter")
	lstButtons.Add(btn)
	Page1.ToolbarButtons = lstButtons
End Sub

Private Sub GetFilterQuery As String
	'a query will look like something
	' WHERE FirstName = 'John'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY'
	' WHERE FirstName = 'John' AND City = 'London'
	' WHERE FirstName = 'John' AND LastName = 'KENNEDY' AND City = 'London'
	'the single quotes are needed because the values are strings

	Dim Query1 = " WHERE " As String	'beginning of the query1
	
	Dim col, col_1 As Int
	For col = 1 To Main.ColNumber - 1
		col_1 = col - 1
		If picFilterItems(col_1).GetSelectedRow(0) > 0 Then
			If col = 1 Then
				Query1 = Query1 & Main.ColNames(col) & " = '" & picFilterItems(col_1).GetSelectedItem(0) & "' "
			Else
				If Query1 = " WHERE " Then
					Query1 = Query1 & Main.ColNames(col) & " = '" & picFilterItems(col_1).GetSelectedItem(0) & "' "
				Else
					Query1 = Query1 & BooleanOperator & Main.ColNames(col) & " = '" & picFilterItems(col_1).GetSelectedItem(0) & "' "
				End If
			End If
		End If
	Next
	
	'if nothing was selected set Query = ""
	If Query1 = " WHERE " Then
		Query1 = ""
	End If
	
	Return Query1
End Sub

Private Sub UpdateFilter(col As Int)
	Private Query1 As String
	
	Query1 = "SELECT DISTINCT " & Main.ColNames(col) & " FROM " & Main.SQLTabelName & " ORDER BY " & Main.ColNames(col) & " ASC"
	
	Dim lst As List
	lst.Initialize
	
	lst.Add("no filter")
	Private rs As ResultSet
	Dim row As Int
	rs = Main.SQL1.ExecQuery(Query1)
	
	row = -1
	Do While rs.NextRow
		row = row + 1
		lst.Add(rs.GetString(Main.ColNames(col)))
	Loop
	picFilterItems(col - 1).SetItems(0, lst)
	rs.Close
End Sub
